﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using iikoCardISSApp;

namespace iikoCardISConsole
{
    public interface IMainView
    {
        /// <summary>
        /// Изменен путь к файлу конфигурации
        /// </summary>
        event ObjectDelegate<string> OnConfigPathSpecified;

        /// <summary>
        /// Изменены общие параметры приложения
        /// </summary>
        event ObjectDelegate<ModelConfig> OnModelConfigNeedSave;

        /// <summary>
        /// Изменена конфигурация сервиса
        /// </summary>
        event ObjectDelegate<iikoCardISConfig> OnConfigChanged;

        /// <summary>
        /// Выбран файл импорта
        /// </summary>
        event ObjectDelegate<string> OnImportFileSelected;

        /// <summary>
        /// Необходима операция экспорта
        /// </summary>
        event ObjectDelegate<string> OnExportOperationNeed;

        /// <summary>
        /// Выбросить исключение
        /// </summary>
        /// <param name="ex"></param>
        void RaiseException(Exception ex);

        /// <summary>
        /// Конфигурация сервиса
        /// </summary>
        iikoCardISConfig Config
        {
            get;
            set;
        }

        /// <summary>
        /// Установка полей представления по параметрам модели
        /// </summary>
        /// <param name="c"></param>
        void SetModelConfig(ModelConfig c);

        /// <summary>
        /// Установить общие свойства представления
        /// </summary>
        /// <param name="args"></param>
        void SetCommonProps(params object[] args);

    }
}
