﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;
using System.Xml;
using System.IO;
using System.Drawing;

namespace iikoCardISConsole
{
    /// <summary>
    /// Конфигурация консольного приложения
    /// Содержит значения полей
    /// </summary>
    public class ModelConfig
    {
        public enum ViewModes
        {
            User,Admin
        }

        public enum WorkModes
        {
            BuildIn, Service
        }

        /// <summary>
        /// Режим работы
        /// </summary>
        public WorkModes WorkMode
        {
            get;
            set;
        }

        /// <summary>
        /// Размер представления
        /// </summary>
        public Size ViewSize
        {
            get;
            set;
        }

        /// <summary>
        /// Позиция представление
        /// </summary>
        public Point Position
        {
            get;
            set;
        }

        /// <summary>
        /// Режим отображения
        /// </summary>
        public ViewModes ViewMode
        {
            get;
            set;
        }

        public string ServiceConfigPath
        {
            get;
            set;
        }

        public DateTime ExportFrom
        {
            get;
            set;
        }

        public DateTime ExportTo
        {
            get;
            set;
        }

        public void Save(string path)
        {
            XmlSerializer xg = new XmlSerializer(typeof(ModelConfig));

            var xw = XmlWriter.Create(path, new XmlWriterSettings()
            {
                Encoding = Encoding.GetEncoding(1251),
                Indent = true
            });
            xg.Serialize(xw, this);
            xw.Close();

        }

        static public ModelConfig Load(string path)
        {
            ModelConfig cfg = null;

            FileStream fs = null;
            try
            {
                fs = File.Open(path, FileMode.Open, FileAccess.Read, FileShare.ReadWrite);

                XmlSerializer xs = new XmlSerializer(typeof(ModelConfig));

                cfg = (ModelConfig)xs.Deserialize(fs);
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                if (fs != null)
                    fs.Close();
            }

            return cfg;
        }
    }
}
