﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace iikoCardISSApp
{
    public abstract class AbstractOperationCreator
    {
        /// <summary>
        /// Ядро
        /// </summary>
        public iikoCardCore Core
        {
            get;set;
        }

        public AbstractOperationCreator(iikoCardCore core, AbstractMonitor monitor)
        {
            Core = core;
            Monitor = monitor;

            Monitor.Elapsed += new MonitorDelegate(EnqueueOperation);

            monitor.Start();
        }

        /// <summary>
        /// Монитор креатора
        /// </summary>
        public AbstractMonitor Monitor
        {
            get;
            set;
        }

        /// <summary>
        /// Ставит операцию в очередь ядра
        /// </summary>
        abstract public void EnqueueOperation(AbstractMonitor monitor);

    }
}
