﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Timers;

namespace iikoCardISSApp
{
    /// <summary>
    /// Монитор срабатывает, когда наступает указанное время суток
    /// </summary>
    public class TimeMonitor : AbstractMonitor
    {
        Timer timer;

        /// <summary>
        /// Время внутри суток срабатывания монитора
        /// </summary>
        public DateTime TimeOfDay
        {
            get;
            set;
        }

        public override void Start()
        {
            timer = new Timer();
            timer.Interval = 400;
            timer.Elapsed += new ElapsedEventHandler(timer_Elapsed);
            timer.Start();
        }

        void timer_Elapsed(object sender, ElapsedEventArgs e)
        {
            try
            {
                timer.Stop();

                var now = DateTime.Now;

                if (now.Hour == TimeOfDay.Hour && now.Minute == TimeOfDay.Minute && now.Second == TimeOfDay.Second)
                {
                    if (!elapsed)
                    {
                        elapsed = true;

                        if (Elapsed != null)
                            Elapsed(this);
                    }
                }
                else
                {
                    elapsed = false;
                }
            }
            finally
            {
                timer.Start();
            }
        }

        bool elapsed = false;

        public override event MonitorDelegate Elapsed;
    }
}
