﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace iikoCardISSApp
{
    /// <summary>
    /// Абстактная операция службы
    /// </summary>
    [XmlInclude(typeof(StandartImportOperation))]
    [XmlInclude(typeof(StandartExportOperation))]
    public abstract class AbstractOperation
    {
        public AbstractOperation()
        {

        }

        public AbstractOperation(iikoCardCore core)
        {
            Core = core;
        }

        /// <summary>
        /// Ссылка на ядро
        /// </summary>
        [XmlIgnore]
        public iikoCardCore Core
        {
            get;
            set;
        }

        /// <summary>
        /// Имя операции
        /// </summary>
        public abstract string FriendlyName
        {
            get;
        }

        /// <summary>
        /// Автоматическая операция
        /// </summary>
        public bool Auto
        {
            get;
            set;
        }

        /// <summary>
        /// Выполнить операцию
        /// </summary>
        public abstract void Execute();        
    }
}
